#include "Anim.h"

CAnim::CAnim(const CMotion* motion, int col, int row)
	: AnimIndex(0),MotionType(0),AnimCnt(0.0F),PrevMotion(-1){
	for (int i = 0; i < col; i++) {
		for (int j = 0; j < row; j++) {
			VMotion.push_back(motion[i*row + j]);
		}
		WMotion.push_back(VMotion);
		VMotion.clear();
	}
}

void CAnim::Animation(float anim_speed) {
	AnimCnt += anim_speed;
	if (AnimCnt > WMotion[MotionType][AnimIndex].Time) {
		AnimCnt = 0;
		AnimIndex++;
		if (WMotion[MotionType][AnimIndex].No == MLOOP) {
			AnimIndex = 0;
		}
		else if (WMotion[MotionType][AnimIndex].No == MEND) {
			MotionType = 0;
			AnimIndex = 0;
		}
		else if (WMotion[MotionType][AnimIndex].No == MSTOP) {
			AnimIndex--;
		}
		else {

		}
	}
}

void CAnim::MotionChange(int motion) {
	if (motion == PrevMotion) return;
	PrevMotion = motion;
	//[VύX̓
	//Wv[VA[V֒ڈڍs邱Ƃ͂ȂB
	if ((MotionType == JUMP || MotionType == LAND) && motion == STAND) return;
	if (MotionType == JUMP && motion == WALK) return;
	AnimIndex = 0;
	AnimCnt = 0;
	MotionType = motion;
}