#include "Main.h"
#include "Collision.h"
#include <math.h>

CCollision::CCollision(POINT pt[], float offset_l, float offset_u, float offset_r, float offset_d, int col_type,CGameMain* game)
	:OffsetL(offset_l),OffsetU(offset_u),OffsetR(offset_r),OffsetD(offset_d),ColType(0){
	Game = game;
	ZeroMemory(mPt, sizeof(mPt));
	for (int i = 0; i < 8; i++) {
		mPt[i].x = pt[i].x;
		mPt[i].y = pt[i].y;
	}
}

//seg1,2i蔻jAoutT1,2̓AoutPos_io͗pj
bool CCollision::ColSegments(Segment &seg1, Segment &seg2, float* outT1, float* outT2, Vector2* outPos) {
	Vector2 v = seg2.s - seg1.s;
	float Crs_v1_v2 = Vector2Cross(&seg1.v, &seg2.v);
	if (Crs_v1_v2 == 0.0F) {
		return false;
	}

	float Crs_v_v1 = Vector2Cross(&v, &seg1.v);
	float Crs_v_v2 = Vector2Cross(&v, &seg2.v);

	float t1 = Crs_v_v2 / Crs_v1_v2;
	float t2 = Crs_v_v1 / Crs_v1_v2;

	if (outT1)
		*outT1 = Crs_v_v2 / Crs_v1_v2;
	if (outT2)
		*outT2 = Crs_v_v1 / Crs_v1_v2;

	const float eps = 0.00001f;
	if (t1 + eps < 0 || t1 - eps > 1 || t2 + eps < 0 || t2 - eps > 1) {
		// ĂȂ
		return false;
	}
	//o͗pB
	if (outPos)
		*outPos = seg1.s + seg1.v * t1;

	return true;
}

Vector2 CCollision::GetMatrixPos(float myx, float myy) {
	DWORD cwidth = Game->MapData().GetChipWidth();
	DWORD cheight = Game->MapData().GetChipHeight();
	int x = (int)(myx / cwidth);
	int y = (int)(myy / cheight);
	return Vector2((float)x * cwidth, (float)y * cheight);
}

POINT CCollision::CheckMap(int x, int y,float addx, float addy) {
	POINT pt[] = {
		{ x + mPt[0].x,	y + mPt[0].y },//
		{ x + mPt[1].x,	y + mPt[1].y },//^
		{ x + mPt[2].x,	y + mPt[2].y },//E

		{ x + mPt[3].x,	y + mPt[3].y },//^
		{ x + mPt[4].x,	y + mPt[4].y },//E^

		{ x + mPt[5].x,	y + mPt[5].y },//
		{ x + mPt[6].x,	y + mPt[6].y },//^
		{ x + mPt[7].x,	y + mPt[7].y },//E
	};
	POINT res{ x,y };
	DWORD cwidth = Game->MapData().GetChipWidth();
	DWORD cheight = Game->MapData().GetChipHeight();
	//C[1lp`B
	for (int i = 0; i < 8; i++) {
		int index = Game->MapData().GetValue(1, pt[i].x / cwidth, pt[i].y / cheight);
		//΂ߏ̔B
		int indexslope = GetChipLayerNum(x, y);
		int src_x = (index % Game->GetBitCount()) * cwidth;
		int src_y = (index / Game->GetBitCount()) * cheight;
		//⓹̓蔻肪̂ȂA-2ԂB
		if (indexslope != 0) {
			res.x = -2;
			res.y = -2;
			return res;
		}
		//⓹̓蔻肪Ȃ͏̓蔻sB
		if (src_x == 0 && src_y == 0) {
			res.x = pt[i].x / cwidth; // ǂ̍W
			res.y = pt[i].y / cheight;
			return res; // ǂ̍WԂ
		}
	}
	res.x = -1;//܂ŗ瓖ĂȂƂ
	res.y = -1;
	return res;
}

int CCollision::GetChipLayerNum(int x, int y) {
	POINT pt[] = {
		{ x + mPt[0].x,	y + mPt[0].y },//
		{ x + mPt[1].x,	y + mPt[1].y },//^
		{ x + mPt[2].x,	y + mPt[2].y },//E

		{ x + mPt[3].x,	y + mPt[3].y },//^
		{ x + mPt[4].x,	y + mPt[4].y },//E^

		{ x + mPt[5].x,	y + mPt[5].y },//
		{ x + mPt[6].x,	y + mPt[6].y },//^
		{ x + mPt[7].x,	y + mPt[7].y },//E
	};
	DWORD cwidth = Game->MapData().GetChipWidth();
	DWORD cheight = Game->MapData().GetChipHeight();
	//forŏsĂ̂́A蔻̃C[邩ȂB
	for (int i = 0; i <= MaxLayerNum; i++) {
		for (int j = 0; j < 8; j++) {
			int index = Game->MapData().GetValue(i + 2, pt[j].x / cwidth, pt[j].y / cheight);
			int src_x = (index % Game->GetBitCount()) * cwidth;
			int src_y = (index / Game->GetBitCount()) * cheight;
			//CԍɁAՓ˂ĂB
			if (src_x == 0 && src_y == 0) {
				//C[ԍԂB
				return i + 2;
			}
		}
	}
	//Ô߁B
	return 0;
}

POINT CCollision::CheckSlopeBlock(int x, int y, int layernum, int addy) {
	POINT pt[] = {
		{ x + mPt[0].x,	y + mPt[0].y },//
		{ x + mPt[1].x,	y + mPt[1].y },//^
		{ x + mPt[2].x,	y + mPt[2].y },//E

		{ x + mPt[3].x,	y + mPt[3].y },//^
		{ x + mPt[4].x,	y + mPt[4].y },//E^

		{ x + mPt[5].x,	y + mPt[5].y },//
		{ x + mPt[6].x,	y + mPt[6].y },//^
		{ x + mPt[7].x,	y + mPt[7].y },//E
	};
	POINT res = { x,y };
	DWORD cwidth = Game->MapData().GetChipWidth();
	DWORD cheight = Game->MapData().GetChipHeight();
	for(int i = 0; i < 8; i++){
		int index = Game->MapData().GetValue(layernum , pt[i].x / cwidth, pt[i].y / cheight);
		int src_x = (index % Game->GetBitCount()) * cwidth;
		int src_y = (index / Game->GetBitCount()) * cheight;
		//⓹̓蔻肪Ȃ͏̓蔻sB
		if (src_x == 0 && src_y == 0) {
			res.x = pt[i].x / cwidth; // ǂ̍W
			res.y = pt[i].y / cheight;
			return res; // ǂ̍WԂ
		}
	}
	res.x = -1;
	res.y = -1;
	return res;
}

Vector2 CCollision::CheckSlope(int x, int y, Segment& Slope, int layernum,int slopecond,int addy) {
	//蔻B
	POINT pt[] = {
		{ x + mPt[0].x,	y + mPt[0].y },//
		{ x + mPt[1].x,	y + mPt[1].y },//^
		{ x + mPt[2].x,	y + mPt[2].y },//E

		{ x + mPt[3].x,	y + mPt[3].y },//^
		{ x + mPt[4].x,	y + mPt[4].y },//E^

		{ x + mPt[5].x,	y + mPt[5].y },//
		{ x + mPt[6].x,	y + mPt[6].y },//^
		{ x + mPt[7].x,	y + mPt[7].y },//E
	};
	DWORD cwidth = Game->MapData().GetChipWidth();
	DWORD cheight = Game->MapData().GetChipHeight();
	Segment Player;
	switch (slopecond) {
	//1͉̉B
	case 1:
		Player.s = { (float)pt[2].x,(float)pt[2].y };
		Player.v = { (float)pt[5].x,(float)pt[5].y };
		break;
	//2͏̏B
	case 2:
		Player.s = { (float)pt[7].x,(float)pt[7].y };
		Player.v = { (float)pt[0].x,(float)pt[0].y };
		break;
	//3͏̏B
	case 3:
		Player.s = { (float)pt[5].x,(float)pt[5].y };
		Player.v = { (float)pt[2].x,(float)pt[2].y };
		break;
	//0͉̏Bi0ȊO͑z肵ĂȂ̂Bj
	default:
		Player.s = { (float)pt[0].x,(float)pt[0].y };
		Player.v = { (float)pt[7].x,(float)pt[7].y };
		break;
	}
	Vector2 res = { (float)x,(float)y };
	//fobOpB
	float T1;
	float T2;
	Vector2 Vres;
	int PlayerCond;
	//̂͂Ă邪cBC[̐llɌ肻B
	if (Slope.s.x >= Player.v.x && Player.v.x < Slope.v.x || Slope.s.x <= Player.v.x && Player.v.x > Slope.v.x) {
		PlayerCond = 1;
	}
	else {
		PlayerCond = 0;
	}

	if (PlayerCond != 0) {
		if (ColSegments(Slope,Player,&T1,&T2,&Vres)) {
			res.x = x-T2;
			res.y = y-T2;
			return res;
		}
		else {
			res.x = x + T2;
			res.y = y + T2;
		}
	}
	else {
		//ȂقǁA蓾ȂWAC[̐llȂ킯cB
		res.x = -2;
		res.y = -2;
		return res;
	}
	//܂ŗՓ˂ĂȂƂƁB
	res.x = -1;
	res.y = -1;
	return res;
}

void CCollision::GetXPosition(float* myx, float* myy, float* addx, float* addy) {
	float newx;
	float tempx = *myx;
	float tempaddx = *addx;

	newx = tempx + tempaddx;
	POINT block = CheckMap((int)newx, (int)*myy, *addx, *addy);
	//XWՓ˂ĂȂB
	if (block.x == -1) {
		*myx = newx;
	}
	//XW⓹̃C[ɂB
	else if(block.x == -2){
		int Layer = GetChipLayerNum((int)*myx, (int)*myy);
		Segment Slope;
		//X[v̏B
		int SlopeCond;
		switch (Layer) {
		case 2:
			Slope.s = GetMatrixPos(newx, *myy + 16.0F);
			Slope.v = GetMatrixPos(newx + 16.0F, *myy);
			SlopeCond = 0;
			break;
		}
		POINT slopeblock = CheckSlopeBlock((int)newx, (int)*myy, Layer);
		Vector2 slope = CheckSlope((int)newx, (int)*myy, Slope, Layer,SlopeCond);
		//-2ԂAubNƂĈB
		if (slope.x == -1) {
			*myx = newx;
		}
		else if (slope.x == -2) {
			//߂荞ݖh~B
			*myx = newx;
		}
		else {
			//߂荞ݖh~B
			*myx = slope.x;
		}
	}
	//ubN̓蔻B
	else {
		if (tempaddx > 0) {
			*myx = (float)((block.x - 1) * 16 + 8 + OffsetR - 0.1f);
		}
		else {
			*myx = (float)((block.x + 1) * 16 + 8 + OffsetL + 0.1f);
		}
		*addx = 0;//Ă̂ňړȂB
	}
}

void CCollision::GetYPosition(float* myx, float* myy, float* addx, float* addy, int* jcount, bool* gflag) {
	float tempaddx = *addx;
	float newy = *myy + *addy;
	POINT block = CheckMap((int)*myx, (int)newy,*addx,*addy);
	//YWՓ˂ĂȂB
	if (block.y == -1) {
		*myy = newy;
		*gflag = false;
	}
	//YW⓹̃C[ɂB
	else if(block.y == -2){
		int Layer = GetChipLayerNum((int)*myx, (int)newy);
		Segment Slope;
		//X[v̏B
		int SlopeCond;
		switch (Layer) {
		case 2:
			Slope.s = GetMatrixPos(*myx, newy + 16.0F);
			Slope.v = GetMatrixPos(*myx + 16.0F, newy);
			SlopeCond = 0;
			break;
		}
		POINT slopeblock = CheckSlopeBlock((int)*myx, (int)newy, Layer);
		Vector2 slope = CheckSlope((int)*myx, (int)newy, Slope, Layer,SlopeCond);
		//-2ԂAubNƂĈB
		if (slope.y == -1) {
			*gflag = true;
			*addy = 0;
		}
		else if (tempaddx != 0 && slope.y != -2) {
			*gflag = true;
			*myy = slope.y;
		}
		else if (slope.y == -2) {
			*gflag = true;
			*addy = tempaddx;
			*myy = newy;
		}
	}
	//ubN̓蔻B
	else {
		if (*addy < 0) {
			*myy = (float)((block.y + 1) * 16 + 8 + OffsetU + 0.1f);
		}
		else {
			*myy = (float)((block.y - 1) * 16 + 8 + OffsetD - 0.1f);
			*jcount = 0;
			*gflag = true;
		}
		*addy = 0;
	}
}

void CCollision::GetMove(float* myx, float* myy, float* addx, float* addy, int* jcount, bool* gflag) {
	GetXPosition(myx, myy, addx, addy);

	if (*addy > GRAVMAX)
	{
		*addy = GRAVMAX;
	}
	else
	{
		*addy += GRAV;
	}

	GetYPosition(myx, myy, addx, addy, jcount, gflag);
}